"use strict";

var oex = window.opera.extension, cfg = window.widget ? window.widget.preferences : {}, toutb, fields, keys, sieve_set, rgxNewLine, rgxHash = /^[^#]*#([^\/]+).*$/, menu,
	LN = function (s) { return LNG[s] || s; };

window.onhashchange = function(e) {
	var args = [],
		old = e.oldURL.indexOf("#") > -1 ? e.oldURL.replace(rgxHash, "$1") : "viewer",
		hash = e.newURL.indexOf("#") > -1 ? e.newURL.substr(e.newURL.indexOf("#") + 1) : "viewer";

	if (hash.indexOf("/") > -1) {
		args = hash.split("/");
		hash = args.shift();
	}

	if (old != hash && window[old + "_sec"]) {
		(window[old + "_sec"].style.display = "none");
	}

	window[hash + "_sec"] && (window[hash + "_sec"].style.display = "block");

	menu.active && menu.active.classList.remove("active");
	(menu.active = menu.querySelector('a[href="#' + hash + '"]')).classList.add("active");

	switch (hash) {
		case "camera" :
			CameraUI.init();
		break;

		case "sieve" :
			sieveUI.load();
		break;
		case "gallery" :
			GalleryUI.init();
		break;
/*		case "info" :

			if (args[0] == "undefined") {
				welcome.style.display = "block";
			}
			else if (args[0] == "update") {
				update.style.display = "block";
			}
			else if (args[0]) {
				alert("woohoooo " + args[0])
			}

			if (news_container.textContent.length < 20) {
				var XHR = new XMLHttpRequest();
				XHR.onreadystatechange = function () { if (XHR.readyState == 4 && this.status === 200) { news_container.innerHTML = XHR.responseText; } };
				XHR.open("GET", "url", true);
				XHR.send(null);
			}
		break;*/
	}
};

window.addEventListener("load", function() {
	var imagus_ver = document.getElementById("imagus_version");
	window.widget && (imagus_ver.textContent = widget.name + " v" + widget.version);

	if (!window.opera || window.opera.version() < 11.60) {
		document.body.outerHTML = '<body style="display:block"><a href="' + imagus_ver.nextElementSibling.href + '" class="fr">' + imagus_ver.textContent + '</a><div class="versionError">This extension works only in Opera 11.60 or above!<br><span style="font-size:12px">Your version: ' + window.opera.version() + " build " + window.opera.buildNumber() + '<br><br><a href="http://my.opera.com/community/download.pl?ref=Deathamns&p=opera_desktop">Install latest Opera!</a></div></body>';
		return;
	}

	if (LNG && window.navigator.language != "en") {
		var i = 0, els = document.body.querySelectorAll("[data-lng]"), l = els.length;

		for (; i < l; ++i) {
			if (LNG[els[i].dataset["lng"]]) {
				els[i][els[i].dataset["lngattr"] || "innerHTML"] = LNG[els[i].dataset["lng"]];
			}
		}
	}

	keys = document.querySelectorAll('input[name^="tools_key-"][maxlength]');
	fields = document.querySelectorAll("input[name*=_], select[name*=_], textarea[name*=_]");

	load();

	menu = document.body.querySelector("nav");
	window.onhashchange({newURL: window.location.hash || "#viewer", oldURL: "#viewer"});

	document.body.style.display = "block";

	for (var key in keys) {
		keys[key].onkeypress = ck;
	}

	var input_changes = {};

	document.forms[0].onchange = function (e) {
		var defval;

		if (e.target.name.indexOf("_") > 0) {
			defval = "def";
		}
		else if (e.target.parentNode.dataset["form"] || e.target.parentNode.parentNode.dataset["form"]) {
			defval = "default";
		}

		if (!defval) { return; }

		if ((e.target.type == "checkbox" && e.target[defval + "Checked"] != e.target.checked) || (e.target.type != "checkbox" && e.target[defval + "Value"] != e.target.value)) {
			input_changes[e.target.name] = true;
		}
		else {
			delete input_changes[e.target.name]
		}

		if (Object.keys(input_changes).length) {
			document.getElementById("save_button").style.color = "#e03c00";
		}
		else {
			document.getElementById("save_button").style.color = "";
		}
	};

	rgxNewLine = /(?:\n|\r\n?)+/;

	document.getElementById("reset_button").onclick = function (e) {
		var rb = this;

		if (this.pending) {
			input_changes["form_resetted"] = true;
			clearTimeout(this.pending);
			delete this.pending;
			rb.style.color = "";
			rb.nextElementSibling.style.color = "#e03c00";
			rb.style.color = "green";
			this.pending = setTimeout(function () { delete rb.pending; rb.style.color = "#000"; }, 2000);
			return;
		}

		rb.style.color = "orange";

		rb.pending = setTimeout(function () {
			delete rb.pending;
			rb.style.color = "#000";
		}, 2000);

		e.preventDefault();
	};

	document.getElementById("save_button").onclick = function () {
		this.style.color = "green";
		clearTimeout(toutb);
		toutb = setTimeout(function(t) { return function() { t.style.color = ""; } }(this), 2000);
		save();
		return !1
	};

	Array.prototype.forEach.call(document.body.querySelectorAll('h3.hide'), function (el) { el.addEventListener("click", function (e) { e.target.classList.toggle('hide'); }); });
}, false);

var sieveUI = {
	loaded: false,
	lastClicked: null,
	fakeCntr: 0,
	rgxQuote: /"/g,
	rgxLt: /</g,
	load: function () {
		if (this.loaded) { return; }
		var name, sfrag = document.createDocumentFragment(), row;

		sieve_set = JSON.parse(cfg.sieve || "{}");

		for (name in sieve_set) { sfrag.appendChild(sieveUI.gen(name, sieve_set[name])); }

		sieve_container.innerHTML = "";
		sieve_container.appendChild(sfrag);

		sieve_container.onkeypress = function (e) {
			var rname;

			if (e.target.nodeName != "SPAN") { return; }
			if ((e.keyCode === 27 || e.keyCode === 13)) {
				e.preventDefault();

				rname = e.target.textContent.trim();

				if (e.keyCode === 27 && rname == "" && !Array.prototype.some.call(e.target.parentNode.querySelectorAll('input[type="text"], textarea'), function (el) { return el.value.trim() != ""; })) {
					e.target.parentNode.parentNode.removeChild(e.target.parentNode);
				}
				else {
					if (/^[^\r\n,]+$/.test(rname)) {
						e.target.textContent = rname;
						e.target.parentNode.querySelector('input[type="text"]').focus();
						e.target.contentEditable = false;
						e.target.className = "";
					}
					else {
						alert(LN("SIV_RULENAMECOND"));
					}
				}
			}
		};

		sieve_container.onmousedown = sieveUI.move;
		sieve_container.onclick = sieveUI.click;
		sieve_container.oncontextmenu = sieveUI.rename_del;

		document.getElementById("sieve_search").onkeypress = function (e) {
			if (e.keyCode == 27 || e.keyCode == 13) {
				e.preventDefault();
			}
		};

		document.getElementById("sieve_search").onkeyup = function (e) {
			if (e.keyCode == 27) {
				this.value = "";
			}

			sieveUI.search(this.value);

			if (e.keyCode == 13) {
				var visibles = document.querySelectorAll('#sieve_container > div:not(.hidden)');

				if (document.querySelectorAll('#sieve_container > div:not(.hidden)').length === 1) {
					visibles[0].classList.toggle('opened');
				}
			}
		};

		this.loaded = true;
	},
	gen: function (n, sd) {
		++this.fakeCntr;
		sd = sd || {};
		var r = document.createElement("DIV");
		sd.off && r.classList.add("disabled");
		r.rule = true;
		r.innerHTML = "<span>" + (n || "") + '</span><div data-form="1">\
<label><input type="checkbox" name="loop[' + this.fakeCntr + ']"' + (sd.loop ? ' checked': '') +'> ' + LN('SIV_LOOP') + ' </label>\
<label><input type="checkbox" name="decode[' + this.fakeCntr + ']"' + (sd.decode ? ' checked': '') +'> ' + LN('SIV_DECODE') + ' </label>\
<label><input type="checkbox" name="useimg[' + this.fakeCntr + ']"' + (sd.useimg ? ' checked': '') +'> ' + LN('SIV_USEIMG') + ' </label>\
<input type="text" name="link[' + this.fakeCntr + ']" value="' + (sd.link ? sd.link.substr(1).replace(this.rgxQuote, '&quot;') : '') + '" placeholder="link">\
<input type="checkbox" name="link_case[' + this.fakeCntr + ']"' + (sd.link && sd.link[0] == 'i' ? ' checked' : '') + ' title="' + LN('SIV_CI') + '">\
<input type="text" name="url[' + this.fakeCntr + ']" value="' + (sd.url ? sd.url.replace(this.rgxQuote, '&quot;') : '') + '" placeholder="url">\
<textarea type="text" name="res[' + this.fakeCntr + ']" placeholder="res">' + (sd.res ? sd.res.replace(this.rgxLt, '&lt;') : '') + '</textarea>\
<input type="text" name="img[' + this.fakeCntr + ']" value="' + (sd.img ? sd.img.substr(1).replace(this.rgxQuote, '&quot;') : '') + '" placeholder="img">\
<input type="checkbox" name="img_case[' + this.fakeCntr + ']"' + (sd.img && sd.img[0] == 'i' ? ' checked' : '') + ' title="' + LN('SIV_CI') + '">\
<textarea name="to[' + this.fakeCntr + ']" placeholder="to">' + (sd.to ? sd.to.replace(this.rgxLt, '&lt;') : '') + '</textarea>\
<textarea name="note[' + this.fakeCntr + ']" placeholder="note">' + (sd.note ? sd.note.replace(this.rgxLt, '&lt;') : '') + '</textarea></div>';
		return r;
	},
	add: function () {
		if (sieve_container.firstElementChild) {
			sieve_container.insertBefore(this.gen(), sieve_container.firstElementChild);
		}
		else {
			sieve_container.appendChild(this.gen());
		}

		var rule_div = sieve_container.firstElementChild;
		rule_div.className = "opened";
		rule_div.firstElementChild.contentEditable = true;
		rule_div.firstElementChild.className = "focus";
		rule_div.firstElementChild.focus();
	},
	select: function (type) {
		for (var i = 0; i < sieve_container.childElementCount; ++i) {
			sieve_container.childNodes[i].classList[type]("selected");
		}
	},
	click: function (e) {
		if (e.target.nodeName != "SPAN") { return; }
		if (e.button === 0) {
			if (e.shiftKey && sieveUI.lastClicked != null) {
				var child = e.target.parentNode, currentIndex = 0, from, to, to_class = sieve_container.childNodes[sieveUI.lastClicked].classList.contains("selected") ? "add" : "remove";

				while (child = child.previousElementSibling)	{
					currentIndex++;
				}

				from = Math.min(sieveUI.lastClicked, currentIndex);
				to = Math.max(sieveUI.lastClicked, currentIndex);

				for (;from <= to; ++from) {
					sieve_container.childNodes[from].classList[to_class]("selected");
				}
			}
			else if (e.ctrlKey || e.metaKey) {
				sieveUI.lastClicked = 0;
				var child = e.target.parentNode;

				while (child = child.previousElementSibling) {
					sieveUI.lastClicked++;
				}

				e.target.parentNode.classList.toggle("selected");
				e.preventDefault();
			}
			else if (!e.target.isContentEditable) {
				e.target.parentNode.classList.toggle("opened");
			}
		}
	},
	move: function (e) {
		var div = e.target.parentNode, i, list;

		if (e.target.isContentEditable || e.target.nodeName != "SPAN" || div.classList.contains("opened") || e.button !== 0 ) {
			return;
		}

		e.preventDefault();

		document.onmousemove = function (e) {
			if (!div.classList.contains("move")) {
				div.classList.add("move");

				list = sieve_container.querySelectorAll((div.classList.contains("selected") ? ".selected, " : "") + ".move");

				for (i = 0; i < list.length; ++i) {
					if (div != list[i]) {
						list[i].classList.add("move_multi");
					}
				}
			}

			div.style.cssText = "left:" + (e.clientX + 15) + "px;top:" + (e.clientY + 15) + "px";
		};

		document.onmouseup = function (e) {
			if (div.classList.contains("move") && e.target.parentNode.rule) {
				var dcfr = document.createDocumentFragment();

				for (i = 0; i < list.length; ++i) {
					sieve_container.removeChild(list[i]);
					dcfr.appendChild(list[i]);
				}

				sieve_container.insertBefore(dcfr, e.target.parentNode);
			}

			div.classList.remove("move");
			list = sieve_container.querySelectorAll(".move_multi");

			for (i = 0; i < list.length; ++i) {
				list[i].classList.remove("move_multi");
			}

			sieve_container.onmouseover = document.onmouseup = document.onmousemove = null;
		};
	},
	imprt: function () {
	},
	exprt: function () {
		if (sieve_container.childElementCount) {
			var i, list = sieve_container.querySelectorAll("div.selected"), exp = {};

			if (list.length) {
				for (i = 0; i < list.length; ++i) {
					exp[list[i].firstElementChild.textContent] = sieve_set[list[i].firstElementChild.textContent];
				}
			}
			else {
				exp = sieve_set;
			}

			window.open("data:application/x-javascript," + encodeURIComponent(JSON.stringify(exp)));
		}
	},
	disable: function () {
		var i = sieve_container.childElementCount, list = sieve_container.querySelectorAll("div.selected").length, cn = sieve_container.childNodes;

		while (i--) {
			if (!list || cn[i].classList.contains("selected")) {
				cn[i].classList.toggle("disabled");
			}
		}
	},
	remove: function () {
		if (confirm(LN("DELITEMS"))) {
			var i = 0, list = sieve_container.querySelectorAll("div.selected");

			if (list.length) {
				for (;i < list.length; ++i) {
					sieve_container.removeChild(list[i]);
				}
			}
			else {
				sieve_container.innerHTML = "";
			}
		}
	},
	rename_del: function (e) {
		if (e.target.nodeName != "SPAN") { return; }

		if (e.shiftKey) {
			e.preventDefault();
			e.target.textContent = e.target.textContent.trim();
			e.target.contentEditable = !e.target.isContentEditable;
			e.target.className = e.target.isContentEditable ? "focus" : "";
		}
		else if (e.ctrlKey) {
			if (confirm(LN("AREYOUSURE"))) {
				e.target.parentNode.parentNode.removeChild(e.target.parentNode);
			}

			e.preventDefault();
		}
	},
	search: function (what) {
		var i = 0, list = sieve_container.childNodes;
		what = what.toLowerCase();

		for (; i < list.length; ++i) {
			list[i].classList[(!what || list[i].firstElementChild.textContent.toLowerCase().indexOf(what) > -1) ? 'remove' : 'add']("hidden");
		}
	},
	update: function () {
		if (sieve_container.childElementCount === 0 || confirm(LN("SIV_UPDALERT"))) {
			cfg.removeItem("sieve");
			oex.bgProcess.update_prefs();
			setTimeout(function() {
				window.location.reload();
			}, 2500);
		}
	}
},
GalleryUI = {
	loaded: false,
	page: 1,
	pages: 1,
	where: null,
	orderby: "date",
	ascdesc: "DESC",
	ipp: 25,
	total: 0,
	search_f: null,
	rgxName: /[^\/]*$/,
	rgxEscape: /(%|_|")/g,
	init: function () {
		if (GalleryUI.loaded) { return; }

		this.search_f = document.getElementById("gallery_search");
		this.search_f.onkeypress = function (e) {
			clearTimeout(this.timeout);

			if (e.keyCode == 27) {
				this.value = "";
				GalleryUI.search();
				e.preventDefault();
			}
			else {
				if (e.keyCode == 13) {
					GalleryUI.search();
					e.preventDefault();
				}
				else {
					this.timeout = setTimeout(GalleryUI.search, 400);
				}
			}
		};

		gallery_container.nextElementSibling.onclick = gallery_container.previousElementSibling.onclick = function (e) {
			if (e.target.nodeName.toUpperCase() == "A") {
				GalleryUI.page = e.target.textContent;
				GalleryUI.load();
			}
		};

		GalleryUI.loaded = true;
		GalleryUI.load();
	},
	drop: function (force) {
		if (force || confirm(LN("DELITEMS"))) {
			var remove = gallery_container.querySelectorAll("div.selected");

			if (remove.length) {
				this.remove(remove);
			}
			else {
				oex.bgProcess.SQL.run("DROP TABLE gallery");
				oex.bgProcess.SQL.db = null;
				gallery_container.innerHTML = '<h3 class="container_info">' + LN("EMPTY") + "</h3>";
				gallery_container.nextElementSibling.innerHTML = gallery_container.previousElementSibling.innerHTML = "";
			}
		}
	},
	gen: function (r) {
		var labels, source = "", tmpdiv = document.createElement("div");

		labels = r.label == null ? "" : r.label.split(",").map(function (label) { return '<a onclick="GalleryUI.search_f.value=\'' + label + '\';GalleryUI.search_f.focus()">' + label + "</a>"} ).join(", ");

		if (r.source != null) {
			r.source.split("\n").forEach(function (el) {
				switch (el.charAt(0)) {
					case "s": source += '<a href="' + el.substr(2) + '">' + LN("GAL_SOURCE") + "</a>"; break;
					case "t": source += '<a href="' + el.substr(2) + '">' + LN("GAL_TARGET") + "</a>"; break;
				}
			});
		}

		tmpdiv.innerHTML = '<a href="' + r.image + '" ' + (r.thumb == null ? '': 'class="thumb" ') + 'rel="nofollow">' + (r.thumb == null ? decodeURIComponent(r.image.match(this.rgxName)[0]) : '<div style="height:' + Math.min(Math.round(Math.min(r.width, 110) * r.height / r.width), 200) + 'px;background-image:url(data:image/jpeg;base64,' + r.thumb + ')"><span>' + r.width + 'x' + r.height + '</span><br><span>' + decodeURIComponent(r.image.match(this.rgxName)[0]) + '</span></div>') + '<b class="date">' + r.date + "</b></a>" + (source ? '<div class="source">' + source + "</div>" : "") + (labels ? '<div class="labels">' + labels + "</div>" : "");

		tmpdiv.onclick = function (e) {
			if (e.ctrlKey && e.button == 0) {
				e.preventDefault();
				this.classList.toggle("selected");
			}
		};

		tmpdiv.oncontextmenu = function (e) {
			if (e.ctrlKey) {
				e.preventDefault();

				if (confirm(LN("AREYOUSURE"))) {
					this.classList.contains("selected") ? GalleryUI.drop(true) : GalleryUI.remove([this]);
				}
			}
			else if (e.shiftKey) {
				e.preventDefault();
				var labels = window.prompt(LN("GAL_EDITLABELS"), (this.lastElementChild.className == "labels" ? this.lastElementChild.textContent : ""));

				if (labels !== null) {
					oex.postMessage({"cmd": "gallery", "data": {"image": this.firstElementChild.href, "label": labels, "nobubble": true}});
					GalleryUI.search_f.onkeypress({"keyCode": 0});
				}
			}
		};

		return tmpdiv;
	},
	limit: function () {
		var limit;

		if (GalleryUI.pages == GalleryUI.page) {
			limit = GalleryUI.total % GalleryUI.ipp;

			if (limit == 0) {
				limit = GalleryUI.ipp;
			}
		}
		else {
			limit = GalleryUI.ipp;
		}

		return " LIMIT " + (GalleryUI.ipp * (GalleryUI.page - 1)) + " ," + limit;
	},
	load: function () {
		if (this.process) { return; }
		else { this.process = true; }

		var where = GalleryUI.where ? ' WHERE ' + GalleryUI.where.join(' AND '): '';

		oex.bgProcess.SQL.run("SELECT COUNT(*) AS c FROM gallery" + where, [], function (qcq, qcr) {
			GalleryUI.total = qcr.rows[0].c;

			if (GalleryUI.total < 1) {
				if (GalleryUI.where) {
					gallery_container.innerHTML = '<h3 class="container_info">' + LN('NOMATCH') + '</h3>';
				}
				else {
					GalleryUI.drop(true);
				}

				gallery_container.nextElementSibling.innerHTML = gallery_container.previousElementSibling.innerHTML = '';
			}
			else {
				if (GalleryUI.total <= GalleryUI.ipp) {
					GalleryUI.pages = GalleryUI.page = 1;
				}
				else {
					GalleryUI.pages = Math.ceil(GalleryUI.total / GalleryUI.ipp);
					GalleryUI.page = Math.max(1, Math.min(GalleryUI.page, GalleryUI.pages));
				}

				oex.bgProcess.SQL.run("SELECT image, strftime('%Y-%m-%d %H:%M:%S', date) AS date, width, height, source, label, thumb FROM gallery" + where + " ORDER BY " + GalleryUI.orderby + " " + GalleryUI.ascdesc + GalleryUI.limit(), [], function (tx, r) {
					var i, dfrag = document.createDocumentFragment(), pages = '';

					if (GalleryUI.pages > 1) {
						for (i = 1; i <= GalleryUI.pages; ++i) {
							pages += "<a" + (GalleryUI.page == i ? ' class="active"' : "") +">" + i + "</a>";
						}

						i = (GalleryUI.page - 1) * GalleryUI.ipp;
						pages += " " + (i + 1) + " - " + (i + r.rows.length) + " | " + GalleryUI.total;
					}

					gallery_container.nextElementSibling.innerHTML = gallery_container.previousElementSibling.innerHTML = pages;

					for (i = 0; i < r.rows.length; ++i) { dfrag.appendChild(GalleryUI.gen(r.rows[i])); }

					gallery_container.innerHTML = "";
					gallery_container.appendChild(dfrag);
				});
			}

			GalleryUI.process = false;
		});
	},
	search: function () {
		var s = GalleryUI.search_f.value;

		if (s) {
			s = ' LIKE "%' + s.replace(GalleryUI.rgxEscape, '\\$1') + "%\" ESCAPE '\\'";
			GalleryUI.where = ["image" + s + " OR label" + s];
		}
		else {
			GalleryUI.where = null;
		}

		GalleryUI.load();
	},
	remove: function (elems) {
		var to_remove = [];

		Array.prototype.forEach.call(elems, function (el) {
			to_remove.push(el.firstElementChild.href);
			el.parentNode.removeChild(el);
		});

		oex.bgProcess.SQL.run("DELETE FROM gallery WHERE image IN (" + Array(to_remove.length + 1).join("?, ").slice(0, -2) + ")", to_remove);
		GalleryUI.load();
	}
},
CameraUI = {
	loaded: false,
	flip_state: {h: 1, v: 1},
	timer: null,
	init: function () {
		if (this.loaded) { return; }

		this.loaded = true;

		if (navigator.getUserMedia) {
			navigator.getUserMedia("video", function (stream) { video.src = stream; }, function (error) { camera_sec.innerHTML = "<h3>Couldn't get the stream...</h3>"; });
		}
		else {
			camera_sec.innerHTML = '<h3>getUserMedia is not supported in this version...</h3>';
		}
	},
	flip: function (v) {
		if (v) {
			this.flip_state.v = this.flip_state.v === 1 ? -1 : 1;
		}
		else {
			this.flip_state.h = this.flip_state.h === 1 ? -1 : 1;
		}

		video.style.OTransform = "scale(" + this.flip_state.h + ", " + this.flip_state.v + ")";
	},
	capture: function () {
		var c = document.createElement("canvas"),
				ctx = c.getContext("2d");

		c.width = video.videoWidth;
		c.height = video.videoHeight;

		c.style.maxWidth = 160 + "px";
		c.style.maxHeight = (160 * c.height / c.width) + "px";

		if (CameraUI.flip_state.h === -1 || CameraUI.flip_state.v === -1) {
			ctx.translate(CameraUI.flip_state.h === -1 ? c.width : 0, CameraUI.flip_state.v === -1 ? c.height : 0);
			ctx.scale(CameraUI.flip_state.h, CameraUI.flip_state.v);
		}

		ctx.drawImage(video, 0, 0);

		if (shot_slide.childElementCount > 15) {
			shot_slide.removeChild(shot_slide.lastElementChild);
		}

		shot_slide.insertBefore(c, shot_slide.firstChild);
	},
	shoot: function(s) {
		clearTimeout(this.timer);
		this.timer = setTimeout(this.capture, s * 1000);
	}
};

function load() {
	var i, m, mode, pref, prefs = {};

	for(i = fields.length; i--;) {
		if (fields[i].disabled || fields[i].readOnly) { continue; }

		pref = fields[i].name.split("_");

		if (!prefs[pref[0]]) {
			prefs[pref[0]] = JSON.parse(cfg[pref[0]] || "{}");
		}

		if (pref[0] == "tools" && pref[1] == "imgSendToHosts") {
			if (Array.isArray(prefs.tools[pref[1]])) {
				var shidx, shosts = [];

				for (shidx = 0; shidx < prefs.tools[pref[1]].length; ++shidx) {
					shosts.push(prefs.tools[pref[1]][shidx].join("|"));
				}

				fields[i].rows = shosts.length;
				fields[i].value = fields[i].defValue = shosts.join("\n");
			}
		}
		else if (pref[0] == "grants") {
			shosts = [];
			m = prefs.grants;

			if (m && m.length) {
				for (shidx = 0; shidx < m.length; ++shidx) {
					shosts.push((m[shidx][0] ? m[shidx][0] : "") + (m[shidx][2] ? ( m[shidx][2] === 1 ? "!!" : "!") : ( m[shidx][2] === 0 ? "~~" : "~")) + (m[shidx][3] ? "#" + m[shidx][3].join(",") : "") + ":" + m[shidx][1]);
				}
			}

			fields[i].value = fields[i].defValue = shosts.join("\n");
		}
		else if (pref[0] == "tools" && pref[1].indexOf("key-") === 0) {
			m = pref[1].substr(4);

			if (prefs.tools["key_" + m]) {
				fields[i].value = fields[i].defValue = prefs.tools["key_" + m] == "" ? "": String.fromCharCode(prefs.tools["key_" + m]);
			}
		}
		else {
			if (prefs[pref[0]] && prefs[pref[0]][pref[1]] !== undefined) {
				if (fields[i].type == "checkbox") {
					fields[i].checked = fields[i].defChecked = !!prefs[pref[0]][pref[1]];
				}
				else {
					fields[i].value = fields[i].defValue = prefs[pref[0]][pref[1]];

					if (fields[i].type == "range" && fields[i].nextElementSibling && fields[i].nextElementSibling.type == "color") {
						fields[i].nextElementSibling.style.opacity = fields[i].value;
					}
					else if (fields[i].type == "text" && fields[i].previousElementSibling && fields[i].previousElementSibling.type == "color") {
						fields[i].onchange = function () {
							this.previousElementSibling.value = /^#[0-9a-f]{6}/i.test(this.value) ? this.value : "#ffffff";
						};

						fields[i].onchange();

						fields[i].previousElementSibling.onchange = function () {
							this.nextElementSibling.value = this.value;
						};
					}
				}
			}
		}
	}

	GalleryUI.ipp = prefs.tools.galleryIPP;
}

function save() {
	var i, j, m, pref, prefs = {},
		host, shidx, shosts,
		rgxGrant = /^(vw|hz|hi)?(!!?|~~?)(#(?:[^,:]+,?\s*)+)?:(.+)/,
		options, rule, rules = document.querySelectorAll("#sieve_container > div"), param, opt_name;

	if (rules.length) {
		prefs.sieve = {};

		for (i = 0; i < rules.length; ++i) {
			rule = rules[i].firstElementChild.textContent.replace(rgxNewLine, " ");

			if (!rule.trim()) { return; }

			prefs.sieve[rule] = {};
			rules[i].classList.contains("disabled") && (prefs.sieve[rule].off = true);
			options = rules[i].querySelectorAll("input, textarea");

			for (j = 0; j < options.length; ++j) {
				param = options[j].name.substr(0, options[j].name.indexOf("["));

				switch (param) {
					case "loop": case "decode": case "useimg":
						if (options[j].checked) { prefs.sieve[rule][param] = true; }
					break;

					case "note":
						options[j].value = options[j].value.trim();
					case "url": case "to": case "link": case "img": case "res":
						if (!/^\s*$/.test(options[j].value)) { prefs.sieve[rule][param] = options[j].value.replace(/\r\n?/g, "\n"); }
					break;

					case "link_case": case "img_case":
						opt_name = param.split("_")[0];
						if (prefs.sieve[rule][opt_name]) { prefs.sieve[rule][opt_name] = (options[j].checked ? "i" : " ") + prefs.sieve[rule][opt_name]; }
					break;
				}
			}
		}
	}

	for (i = 0; i < fields.length; ++i) {
		if (fields[i].readOnly) { continue; }

		pref = fields[i].name.split("_");

		if (!prefs[pref[0]]) {
			prefs[pref[0]] = {};
		}

		if (pref[0] == "tools" && pref[1] == "imgSendToHosts") {
			shosts = fields[i].value.trim().split(rgxNewLine);
			prefs.tools[pref[1]] = [];

			for (shidx = 0; shidx < shosts.length; ++shidx) {
				host = shosts[shidx].split("|");
				if (host.length === 2 && (/%(?:url|name)/).test(host[1])) { prefs.tools[pref[1]].push(host); }
			}
		}
		else if (pref[0] == "grants") {
			if (fields[i].value == "") { continue; }
			var grnts = fields[i].value.trim().split(rgxNewLine), grant, s_rules;

			if (grnts.length) {
				prefs.grants = [];

				for (shidx = 0; shidx < grnts.length; ++shidx) {
					if (grant = grnts[shidx].match(rgxGrant)) {
						host = [grant[1] ? grant[1] : null];
						host.push(grant[4]);

						if (grant[2][0] == "!") { host.push(grant[2][1] == "!" ? 1 : true); }
						else { host.push(grant[2][1] == "~" ? 0 : false); }

						if (grant[3]) {
							s_rules = grant[3].substr(1).split(/\s*,\s*/);

							if (rules.length) { for (var j = 0; j < s_rules.length; ++j) { if (!prefs.sieve[s_rules[j]]) { delete s_rules[j]; } } }

							if (s_rules.length) { host.push(s_rules); }
						}

						prefs.grants.push(host);
					}
				}
			}
		}
		else if (pref[0] == "tools" && pref[1].indexOf("key-") === 0) {
			prefs.tools["key_" + pref[1].substr(4)] = fields[i].value.charCodeAt(0);
		}
		else {
			if (prefs[pref[0]]) {
				if (fields[i].type == "checkbox") {
					prefs[pref[0]][pref[1]] = fields[i].checked
				}
				else if (fields[i].type == "range" || fields[i].type == "number" || fields[i].classList.contains("number")) {
					prefs[pref[0]][pref[1]] = fields[i].min ? Math.max(fields[i].min, Math.min(fields[i].max, parseFloat(fields[i].value))) : parseFloat(fields[i].value);
					fields[i].value = prefs[pref[0]][pref[1]];
				}
				else {
					prefs[pref[0]][pref[1]] = fields[i].value;
				}
			}
		}
	}

	oex.postMessage({"cmd": "broadcast", "data": "reinit", "prefs": prefs});
	GalleryUI.ipp = prefs.tools.galleryIPP || GalleryUI.ipp;
	GalleryUI.load();
}

function ck(e) {
	var t = e.target;

	if (" 8 9 13 35 36 37 39 46 53 68 88 100 120 ".indexOf(" " + e.keyCode + " ") > -1) {
		return true;
	}

	if (!e.shiftKey && !e.ctrlKey && !(e.keyCode > 47 && e.keyCode < 58 || e.keyCode > 64 && e.keyCode < 91 || e.keyCode > 96 && e.keyCode < 123)) {
		e.preventDefault();
		return false;
	}

	var val = String.fromCharCode(e.keyCode).toUpperCase();

	for (var i = 0; i < keys.length; ++i) {
		if (keys[i].value == val) {
			e.preventDefault();
			return false;
		}
	}

	t.value = val;
}